

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 OrangeRed
#property indicator_color2 Black
#property indicator_color3 Green


extern string Paire = "EURUSD";
extern string Indicator= "CCI";


extern string setup_a=" Indicateur  une seule priode" ;
extern int Priode =14;

extern string setup_b= "Pour le MACD et OSMA";
extern int fast = 12;
extern int slow= 26;
extern int signal =9;

extern string setup_c="Pour le Stochastique";
extern int KPeriod=5;
extern int DPeriod=3;
extern int Slowing=3;

extern string setup_d="Dfinition du style";
extern string Style = "LIGNE";
extern int Style_point= 159;

extern string setup_e="Dfinition du style de prix et MA";
extern string price ="CLOSE";
extern string ma_style ="SMA";


double Idx[];
double Idx_2[];
double Idx_3[];

int init()
{
   IndicatorShortName("Multi indic("+Paire+","+Indicator+","+Priode+")");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Idx);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,Idx_2);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Idx_3);
   return(0);
}

void start()
{
   

   int counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   double prix,mode;
   for(int i=0; i<limit; i++)
   {
   
                                                                 // Dfinition du prix
     if (price == "CLOSE")                  prix= PRICE_CLOSE;
     if (price == "TYPICAL")                prix= PRICE_TYPICAL;
     if (price == "HIGH")                   prix= PRICE_HIGH;
     if (price == "LOW")                    prix= PRICE_LOW;
     if (price == "OPEN")                   prix= PRICE_OPEN;
     if (price == "MEDIAN")                 prix= PRICE_MEDIAN;
     if (price == "WEIGHTED")               prix= PRICE_WEIGHTED;
                                                                 // Dfinition du style moving average
 
     if (ma_style == "SMA")                 mode= MODE_SMA;
     if (ma_style == "EMA")                 mode= MODE_EMA;
     if (ma_style == "LWMA")                mode= MODE_LWMA;
     if (ma_style == "SMOOT")               mode= MODE_SMMA;

                                                                 // Choix des indicateurs de 1 buffer

      if (Indicator == "CCI")    Idx[i]     = iCCI(Paire,0,Priode,prix,i) ; 
      if (Indicator == "RSI")    Idx[i]     = iRSI(Paire,0,Priode,prix,i);
      if (Indicator == "BULL")   Idx[i]     = iBullsPower(Paire, 0, Priode,prix,i);
      if (Indicator == "BEAR")   Idx[i]     = iBearsPower(Paire, 0, Priode,prix,i);
      if (Indicator == "OBV")    Idx[i]     = iOBV(Paire, 0, prix, i);
      if (Indicator == "MOM")    Idx[i]     = iMomentum(Paire,0,Priode,prix,i);
      if (Indicator == "STDEV")  Idx[i]     = iStdDev(Paire,0,Priode,0,mode,prix,i);
      if (Indicator == "MFI")    Idx[i]     = iMFI(Paire,0,Priode,i);
      if (Indicator == "ATR")    Idx[i]     = iATR(Paire,0,Priode,i);
      if (Indicator == "FORCE")  Idx[i]     = iForce(Paire, 0, Priode,mode,prix,i);
      if (Indicator == "AC")     Idx[i]     = iAC(Paire, 0, i);
      if (Indicator == "AO")     Idx[i]     = iAO(Paire, 0, i);
      if (Indicator == "OSMA")   Idx[i]     = iOsMA(Paire,0,fast,slow,signal,prix,i);

                                                                // Choix des indicateur  plusieurs buffers



      if (Indicator == "MACD") Idx[i]       = iMACD(Paire,0,fast,slow,signal,prix,MODE_MAIN,i);
      if (Indicator == "MACD") Idx_2[i]     = iMACD(Paire,0,fast,slow,signal,prix,MODE_SIGNAL,i);
      if (Indicator == "MACD") Idx_3[i]     = iMACD(Paire,0,fast,slow,signal,prix,MODE_MAIN,i)- iMACD(Paire,0,fast,slow,signal,PRICE_CLOSE,MODE_SIGNAL,i);
      
      if (Indicator == "STO") Idx[i]        = iStochastic(Paire,0,KPeriod,DPeriod,Slowing,mode,0,MODE_MAIN,i);
      if (Indicator == "STO") Idx_2[i]      = iStochastic(Paire,0,KPeriod,DPeriod,Slowing,mode,0,MODE_SIGNAL,i);
      
      if (Indicator == "ADX") Idx[i]        = iADX(Paire,0,Priode,prix,MODE_PLUSDI,i);
      if (Indicator == "ADX") Idx_2[i]      = iADX(Paire,0,Priode,prix,MODE_MINUSDI,i);

      
                                                  // Dfinition du nom et des priodes  afficher pour les cas "MACD","Sto" et "OSMA3
      
      if (Indicator == "MACD")    IndicatorShortName("Multi indic("+Paire+","+Indicator+","+fast+","+slow+","+signal+")");
      if (Indicator == "STO")     IndicatorShortName("Multi indic("+Paire+","+Indicator+","+KPeriod+","+DPeriod+","+Slowing+")");
      if (Indicator == "OSMA")    IndicatorShortName("Multi indic("+Paire+","+Indicator+","+fast+","+slow+","+signal+")");

      
      
      
                                                         // Dfinition du style buffer
                                                         
                                                         
     
     if (Style == "LIGNE") SetIndexStyle(0,DRAW_LINE);
                           SetIndexBuffer(0,Idx)  ;      
     if (Style == "HISTO") SetIndexStyle(0,DRAW_HISTOGRAM);
                           SetIndexBuffer(0,Idx);
     if (Style == "POINT") SetIndexStyle(0,DRAW_ARROW);
                           SetIndexArrow(0,Style_point);
                           SetIndexBuffer(0,Idx);
                     
   }
}


